905afdc183b67ed480c913b0cea660a1aa50530b
[rip_dvd/.git] / rip_dvd
1 #!/bin/bash
2 #
3 # Author: Alan J. Pippin (apippin@pippins.net)
4 # Date: 05/17/2009
5 #
6   REV=1.0
7 #
8 # Description: This script wraps a number of linux utilities to
9 # create a recipe for ripping protected DVDs, circumventing 
10 # ARcoSS and CRC checksum error protection schemes used on many
11 # newer DVDs. Edit as appropriate for your needs. I use this to
12 # backup DVDs I own, and do not condone any other activity it
13 # may be used for.
14 #
15 # Known Issues/Limitations:
16 # - Mirror mode is always done in ISO mode
17 #
18 # Package Dependencies (apt-get install these for example):
19 # lsdvd dvdauthor gddrescue dvdbackup tovid mencoder mplayer genisoimage libdvdcss2
20 #
21 # Specific Executable (program) Dependencies (must be found in $PATH):
22 # volname makexml lsdvd dvdauthor gddrescue dvdbackup mencoder mplayer mkisofs
23 #
24 # Optional Dependencies:
25 # lookup imdb info/posters for mythvideo: http://www.mythtv.org/wiki/Fill_mythvideo_metadata.pl
26 #
27
28 ##############################################################################
29 # Local Machine Settings:
30 # Sources both the "default" conf file tracked by GIT (rip_dvd.conf.dist)
31 # and the local conf file created by each local machine (rip_dvd.conf)
32 # Copy the rip_dvd.conf.dist file to rip_dvd.conf and edit the later.
33 # This will allow you to override all the default values to meet your needs
34 # in a way that won't get clobbered when you pull updates from my GIT repo.
35 ##############################################################################
36 config="${0%/*}/rip_dvd.conf"
37 [ -e "${config}.dist" ] && . ${config}.dist
38 [ -e "${config}" ] && . ${config}
39
40 ##############################################################################################
41 # Command line processing
42 ##############################################################################################
43 typeset dvdname=""
44 typeset debug=""
45 typeset dest=""
46 typeset isofile=""
47 typeset vobfile=""
48 typeset dvdpath=""
49 typeset aspect=""
50 typeset SCALE=""
51 typeset CROP=""
52 typeset profile="hdtv"
53 typeset extension=""
54 typeset -i keep_isofile=0
55 typeset -i keep_vobfile=0
56 typeset -i keep_dvdfolder=0
57 typeset -i keep_intermediate_files=0
58 typeset -i make_final_dest_vob=0
59 typeset -i make_final_dest_iso=0
60 typeset -i make_final_dest_folder=0
61 typeset -i make_final_dest_comp=0
62 typeset -i errors=0
63 typeset -i show_usage=0
64 typeset -i mirror_mode=0
65 typeset -i target_bitrate=0
66 typeset -i target_size=0
67 typeset -i audio_2ch=0
68 typeset -i invalid_feature_title=0
69 typeset -i feature_title_override=0
70 typeset -i mplayer_dumpstream_incompatibility=0
71
72 while (($#)) && getopts 2mvifkxht:n:d:b:s:t:a:p:e: opt "$@"
73 do
74     case $opt in
75         (n)     dvdname=$OPTARG;;
76         (d)     dest=$OPTARG;;
77         (b)     target_bitrate=$OPTARG;;
78         (s)     target_size=$OPTARG;;
79         (2)     audio_2ch=1;;
80         (v)     make_final_dest_vob=1;;
81         (i)     make_final_dest_iso=1;;
82         (f)     make_final_dest_folder=1;; 
83         (x)     make_final_dest_comp=1;;
84         (m)     mirror_mode=1;;
85         (k)     keep_intermediate_files=1;;
86         (t)     feature_title_override=$OPTARG;;
87         (a)     aspect=$OPTARG;;
88         (p)     profile=$OPTARG;;
89         (e)     extension=$OPTARG;;
90         (w)     set -$opt;;
91         (h)     show_usage=1;;
92         (:)     echo >&2 "$0: $OPTARG requires a value"; errors=errors+1;;
93         (\?)    echo >&2 "$0: invalid option '$OPTARG'"; errors=errors+1;;
94     esac
95 done
96
97 shift $((OPTIND-1))
98
99 function usage() {
100     echo >&2 "Usage: ${0##*/} -d <destdir> [ <options> ]"
101     echo >&2 "Revision $REV"
102     echo >&2 "Options:"
103     echo >&2 "   -d <destdir>  Specify the destination directory to store the ripped DVD to"
104     echo >&2 "   -n <dvdname>  Specify a path to a DVD folder or file to process:"
105     echo >&2 "                 1) If this option is not specified, the DVD will be ripped from $dev"
106     echo >&2 "                 2) If dvdname exists in $tmpdir, it will be ripped as a DVD instead of $dev"
107     echo >&2 "                 3) If dvdname is a full path to a DVD folder, it will be ripped as a DVD instead of $dev"
108     echo >&2 "                 4) If dvdname is a full path to an MPG2 file, it will be ripped as a DVD instead of $dev"
109     echo >&2 "                 5) If dvdname is a full path to an ISO file, it will be ripped as a DVD instead of $dev"
110     echo >&2 "   -p <profile>  Specify which encoding profile to use in -x mode as shown below:"
111     echo >&2 "                 - hdtv = AVI, Xvid codec, 2 pass encoding (default)"
112     echo >&2 "                 - iphone = MP4, x264 codec, 2 pass encoding, 480:320 scaling"
113     echo >&2 "                 - ipod = MP4, x264 codec, 2 pass encoding, 320:240 scaling"
114     echo >&2 "   -e <ext>      Specify a suffix extension to apply to the end of the final image filename (like .hdtv, .ipod, etc)"
115     echo >&2 "                 If you run multiple instances of this script ripping the same DVD, you need to specify this option."
116     echo >&2 "   -m            Make a mirror image of the DVD and save it as a DVD ISO file"
117     echo >&2 "                 The default operation is non-mirror mode where only the main"
118     echo >&2 "                 feature title will be ripped."
119     echo >&2 "   -v            Make the final image a DVD VOB file"
120     echo >&2 "   -i            Make the final image a DVD ISO file"
121     echo >&2 "   -f            Make the final image a DVD folder"
122     echo >&2 "   -x            Make the final image a compressed file based on your profile selection"
123     echo >&2 "                 You must also specify the target size or bitrate using the '-s' or '-b' options"
124     echo >&2 "   -s <size>     Set the target size of the compressed file in MB (ex: 700, 1000, etc)"
125     echo >&2 "   -b <bitrate>  Set the bitrate desired in the compressed file in kbits/sec (ex: 1500, 2000 (default), etc)"    
126     echo >&2 "   -a <W:H>      Specify the width x height aspect ratio to scale the DVD to (only used in -x mode)"
127     echo >&2 "      <W>        If only the width is given, it will autoset the height to a value which preserves the aspect ratio"
128     echo >&2 "                 The default behavior is autoaspect mode, which preserves the original aspect, with no scaling being done"
129     echo >&2 "   -2            Use 2 channel MP3 audio encoding when making a compressed file (default is 6 channel AC3)"
130     echo >&2 "   -k            Keep the intermediate files (good for debugging)"
131     echo >&2 "                 In -x mode, run with this option to keep the original .VOB file"
132     echo >&2 "                 By default, all intermediary files are deleted. Only the final image is kept"
133     echo >&2 "   -t <title>    Specify the main feature title to pull from the DVD (only required if this script can't figure it out)"
134     echo >&2 "   -w            Set the sh Execute/Verbose flag (causes every command to be echoed)"
135     echo >&2 ""
136     exit 2
137 }
138
139 if (($errors)) || (($show_usage))
140 then
141   usage
142 fi
143
144 # Sanity Check - Command Line Options 
145 if [ "$dest" == "" ]; then
146   echo "-E- You must specify a destination directory with '-d'" | tee -a $logfile
147   usage
148 fi
149
150 if ([ $target_bitrate -ne 0 ] || [ $target_size -ne 0 ] || [ "$aspect" != "" ]) && [ $make_final_dest_comp -ne 1 ]; then
151   echo "-E- You can't specify a bitrate, target_size, or aspect in non compressed file mode. You must specify '-x' when using '-b' or '-s' or '-a'" | tee -a $logfile
152   usage
153 fi
154
155 if [ $target_bitrate -eq 0 ] && [ $target_size -eq 0 ] && [ $make_final_dest_comp -eq 1 ]; then
156   echo "-E- You must specify a bitrate in compressed file mode. You must specify '-b' or '-s' when using '-x'" | tee -a $logfile
157   usage
158 fi
159
160 if [ $make_final_dest_vob -eq 0 ] && [ $make_final_dest_iso -eq 0 ] && 
161    [ $make_final_dest_folder -eq 0 ] && [ $make_final_dest_comp -eq 0 ] && [ $mirror_mode -eq 0 ]; then
162   echo "-E- You must specify what type of final destination you want: '-m' or '-v' or '-i' or '-f' or '-x'" | tee -a $logfile
163   usage
164 fi
165
166 if [ $mirror_mode -eq 1 ]; then
167   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_iso -eq 1 ] || 
168      [ $make_final_dest_folder -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
169     echo "-E- You can't specify '-v' or '-i' or '-f' or '-x' when operating in mirror mode with '-m'" | tee -a $logfile
170     usage
171   fi
172 fi
173
174 # If the aspect ratio option was specified, set the scale variable appropriately for mencoder
175 if [ "$aspect" != "" ]; then
176   echo "$aspect" | grep -q "x"
177   if [ $? == 0 ]; then
178     echo "-E- You must specify the aspect option with a value whose format is W:H"
179     exit 1
180   fi
181   echo "$aspect" | grep -q ":"
182   if [ $? != 0 ]; then
183     SCALE=",scale -zoom -xy $aspect"
184   else
185     SCALE=",scale=$aspect"
186   fi
187 fi
188
189
190 # Sanity Check - Key executables
191 [[ ! -x `which lsdvd` ]] && echo "-E- missing dependency: lsdvd" && exit
192 [[ ! -x `which volname` ]] && echo "-E- missing dependency: volname" && exit
193 [[ ! -x `which ddrescue` ]] && echo "-E- missing dependency: ddrescue" && exit
194 [[ ! -x `which dvdbackup` ]] && echo "-E- missing dependency: dvdbackup" && exit
195 [[ ! -x `which mencoder` ]] && echo "-E- missing dependency: mencoder" && exit
196 [[ ! -x `which makexml` ]] && echo "-E- missing dependency: makexml" && exit
197 [[ ! -x `which dvdauthor` ]] && echo "-E- missing dependency: dvdauthor" && exit
198 [[ ! -x `which mkisofs` ]] && echo "-E- missing dependency: mkisofs" && exit
199
200 ##############################################################################################
201
202 typeset -i ripdvd
203 if [ -z "$dvdname" ]; then
204   # make sure the DVD device is accessible
205   volname $dev > /dev/null 2>&1
206   if [ $? != 0 ]; then
207     echo "-E- Can't access the DVD device $dev"
208     exit 1
209   fi
210   # now capture the volume name from the device
211   dvdname=`volname $dev | awk '{ print $1 }'`
212   ripdvd=1
213 else 
214   # check to see if dvdname is a full path to a real directory
215   # if it is, set dvdname and dvdpath appropriately
216   if [ -d "$dvdname" ]; then
217     dvdpath="$dvdname"
218     dvdname=`basename "$dvdname"`
219     keep_dvdfolder=1
220     if [ -z "$dvdname" ]; then
221      echo "-E- Unable to extract dvdname from path: $dvdpath"
222      exit 1
223     fi
224     if [ ! -d "$dvdpath/VIDEO_TS" ]; then
225       echo "-E- You must supply a full path to a valid DVD folder with this option"
226       exit 1
227     fi
228   fi
229
230   # Check to see if dvdname is a full path to a file
231   if [ -f "$dvdname" ]; then
232     valid_file=0
233
234     # check to see if dvdname is a full path to an MPG2 (VOB) file
235     # if it is, set dvdname and vobfile appropriately
236     file "$dvdname" | grep -q "MPEG"
237     if [ $? == 0 ]; then
238       # It is a valid MPEG2 file, now strip the extension off our dvdname
239       vobfile="$dvdname"
240       dvdname=`basename "$dvdname"`
241       dvdname=${dvdname%.[^.]*}
242       keep_vobfile=1
243       valid_file=1
244     fi
245
246     # check to see if dvdname is a full path to an ISO file
247     # if it is, set dvdname and isofile appropriately
248     file "$dvdname" | grep -q "ISO"
249     if [ $? == 0 ]; then
250       # It is a valid ISO file, now strip the extension off our dvdname
251       isofile="$dvdname"
252       dvdname=`basename "$dvdname"`
253       dvdname=${dvdname%.[^.]*}
254       keep_isofile=1
255       valid_file=1
256     fi    
257
258     # If we didn't find a handler for the file above, complain
259     if [ $valid_file -eq 0 ]; then
260       echo "-E- Unsupported file type: $vobfile"
261       exit 1
262     fi
263   fi
264   ripdvd=0
265 fi
266
267 # remove bad characters from the dvdname
268 dvdname=${dvdname%.} # remove trailing '.' character
269
270 # add the suffix extension to the end of the dvdname
271 dvdname=$dvdname$extension
272
273 # make a "safe" dvdname (remove special characters)
274 safedvdname=`basename "$dvdname" | sed 's/[ !&*\\$?]/_/g'`
275
276 # Make sure we have a non-empty dvdname
277 if [ -z "$dvdname" ]; then
278   echo "-E- unable to determine dvdname"
279   exit 1
280 fi
281
282 # make sure our vobfile value is set
283 if [ -z "$vobfile" ]; then
284   vobfile="$dest/$dvdname.VOB"
285 fi
286
287 # set up some variables to hold various logfiles
288 logfile="$logdir/$dvdname.log"
289 passlogfile="$tmpdir/$safedvdname.log"
290 ddrescuelog=`tempfile`
291 dvdauthorlog=`tempfile`
292 encodelog=`tempfile`
293 dumplog=`tempfile`
294
295 # create the tmpdir if it doesn't already exist
296 if [ ! -d "$tmpdir" ]; then
297   mkdir -p "$tmpdir"
298   if [ $? != 0 ]; then
299     echo "-E- Unable to create the tmpdir: $tmpdir"
300     exit 1
301   fi
302 fi
303
304 # create the logdir if it doesn't already exist
305 if [ ! -d "$logdir" ]; then
306   mkdir -p "$logdir"
307   if [ $? != 0 ]; then
308     echo "-E- Unable to create the logdir: $logdir"
309     exit 1
310   fi
311 fi
312
313 ##############################################################################################
314 # cleanup functions
315 ##############################################################################################
316 cleanup() { 
317   if [ $keep_intermediate_files -eq 0 ]; then
318     [[ -e "$dvdauthorlog" ]] && rm -f "$dvdauthorlog"
319     [[ -e "$ddrescuelog" ]] && rm -f "$ddrescuelog"
320     [[ -e "$encodelog" ]] && rm -f "$encodelog"
321     [[ -e "$dumplog" ]] && rm -f "$dumplog"
322   else
323     [[ -e "$dvdauthorlog" ]] && echo "-> Keeping dvdauthor log: $dvdauthorlog" | tee -a "$logfile"
324     [[ -e "$ddrescuelog" ]] && echo "-> Keeping ddrescue log: $ddrescuelog" | tee -a "$logfile"
325     [[ -e "$encodelog" ]] && echo "-> Keeping encode log: $encodelog" | tee -a "$logfile"
326     [[ -e "$dumplog" ]] && echo "-> Keeping dump log: $dumplog" | tee -a "$logfile"
327   fi
328   echo ""
329 }
330
331 fatal_and_exit() {
332   if [[ -z "$1" ]]; then
333     msg="-E- control-c killed us"
334   else
335     msg=$1
336   fi
337   echo -e 2>&1 "$msg" | tee -a "$logfile"
338   if [[ -n "$mailto" ]]; then
339     echo -e "$msg" | mailx -s "dvd rip of $dvdname FAILED" "$mailto"
340   fi
341   exit 1
342 }
343
344 # Call our cleanup functions on INT and EXIT signals
345 trap fatal_and_exit INT
346 trap cleanup EXIT
347
348 ##############################################################################################
349 # processing functions
350 ##############################################################################################
351 function make_dvd_iso_image {
352
353   isofile="$1"
354
355   # check to see if we have a dvdpath to rip from instead of $dev
356   if [ -z "$dvdpath" ]; then
357     # load the CSS codes in the DVD drive 
358     lsdvd $dev >> "$logfile"
359     if [ $? != 0 ]; then
360       fatal_and_exit "-E- lsdvd $dev failed" 
361     fi
362
363     # read the DVD, ignoring/skipping CRC errors
364     ddrescue -n -b 2048 $dev "$isofile" "$ddrescuelog"
365     if [ $? != 0 ]; then
366       fatal_and_exit "-E- ddrescue -n -b 2048 $dev \"$isofile\" failed"
367     fi
368     cat "$ddrescuelog" >> "$logfile"
369   else
370     # rip from a path instead
371     make_dvd_iso_image_from_folder "$dvdpath" "$isofile" 1
372   fi
373 }
374
375 function make_dvd_iso_image_from_folder {
376   
377   src="$1"
378   dst="$2"
379   handle_error=$3
380   
381   echo "-> Creating ISO image of DVD video: $src -> $dst" | tee -a "$logfile"
382
383   # make an iso image out of our directory
384   echo "   mkisofs -dvd-video \"$src\" 2>> \"$dumplog\" | dd of=\"$dst\" obs=32k seek=0 > /dev/null 2>> $dumplog" >> "$logfile"
385   mkisofs -dvd-video "$src" 2>> "$dumplog" | dd of="$dst" obs=32k seek=0 > /dev/null 2>> "$dumplog"
386
387   # set the audio languages from the iso if it exists and is non-zero in size
388   if [ -s "$dst" ]; then
389     get_feature_title "$dst"
390     get_audio_id_from_iso "$dst"
391   fi
392
393   # make sure we were able to create the iso image from the folder given to us
394   if [ ! -s "$dst" ] && [ $handle_error -eq 1 ]; then
395     echo "-> Unable to make an iso image from the DVD folder: $dvdpath"
396     echo "   Falling back to mplayer to create a main feature VOB from the folder instead: $dvdpath"
397     # remove the bad iso file
398     [[ -e "$dst" ]] && rm -f "$dst"
399     # get the feature title from the DVD folder
400     get_feature_title "$dvdpath"
401     # create our main VOB file from the ISO
402     create_main_vob_with_mplayer "$dvdpath" 
403     # get our audio id from the VOB file
404     get_audio_id_from_vob "$vobfile"
405   fi
406 }
407
408 function make_dvdbackup_folder_image {
409   # extract the feature title from the DVD image
410   echo "-> Extracting feature title using dvdbackup" | tee -a "$logfile"
411   [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
412   dvdbackup -F -i "$isofile" -o "$tmpdir" >> "$logfile"
413   if [ $? != 0 ]; then
414     fatal_and_exit '-E- dvdbackup -F -i "$isofile" -o "$tmpdir" failed'
415   fi
416 }
417
418 function make_dvdauthor_folder_image {
419   # create a new DVD video of the feature title
420   echo "-> Creating DVD video $dest/$dvdname" | tee -a "$logfile"
421   [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
422   dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
423   cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
424
425   # There is a chance that dvdauthor won't like some of the VOBs.
426   # We can't tell ahead of time which ones it will choke on. 
427   # So, we need to run it over and over again until it can process
428   # all the VOBs. If it can't handle one of them, run it through
429   # mencoder to fix it and try again. These errors are typically
430   # present due to the copy protection that ddrescue removed.
431   grep -q "SCR moves" $dvdauthorlog
432   while [ $? == 0 ]; do
433     # fix bad vobs that get the "SCR moves backwards" error:
434     #  STAT: Processing VTS_01_0.VOB...
435     #  ERR:  SCR moves backwards, remultiplex input.
436     badvob=`grep -v "^WARN:" $dvdauthorlog | grep -B 1 "SCR moves" | grep "Processing" | awk '{ print $3 }' | sed -e 's/\.\.\.//'`
437     if [[ ! -f "$badvob" ]]; then
438       fatal_and_exit "-E- Found a bad VOB, but could not extract it's name properly: $badvob"
439     fi
440     echo "-> Fixing SCR errors in DVD video file $badvob" | tee -a "$logfile"
441     cat $badvob | mencoder $lang_opts -quiet -of mpeg -mpegopts format=dvd -oac copy -ovc copy - -o $badvob.fixed >> "$logfile" 2>&1
442     mv -f $badvob.fixed $badvob
443     echo "-> Creating DVD video $dest/$dvdname"
444     dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
445     cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
446     grep -q "SCR moves" $dvdauthorlog
447   done
448 }
449
450 function get_feature_title {
451   source="$1"
452   # if a feature title was given on the command line, use it
453   if [ $feature_title_override -ne 0 ]; then
454     feature_title=$feature_title_override
455     return 0
456   fi
457   # otherwise, use lsdvd to figure it out
458   if [ $ripdvd -eq 1 ]; then
459     feature_title=`lsdvd $dev | awk '/Longest/ { print $NF }'`
460   else 
461     feature_title=`lsdvd "$source" 2>/dev/null | awk '/Longest/ { print $NF }'`
462   fi
463 }
464
465 function create_main_vob_with_cat {
466   # cd to the feature title DVD folder
467   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
468   if [ $? != 0 ]; then
469     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
470   fi
471
472   # concatenate all the VOBs together into 1 giant VOB
473   vobs=`/bin/ls -1 VTS*.VOB | grep -v "0.VOB" | tr '\n' ' '`
474   cat $vobs > "$tmpdir/$dvdname.VOB"
475
476   # cd back to the dir we started from
477   popd > /dev/null 2>&1
478 }
479
480 function create_main_vob_with_mplayer {
481
482   # argument processing  
483   source="$1"
484   remove_dumplog=$2
485
486   # make sure we have a valid feature title
487   if [ $invalid_feature_title -eq 1 ] && [ $feature_title_override -eq 0 ]; then
488     fatal_and_exit "-E- You must have a valid feature title to get the VOB via mplayer dumpstream. We can't determine the feature title for this DVD."
489   fi
490
491   # check to make sure we didn't detect an mplayer dumpstream incompatibility earlier
492   if [ $mplayer_dumpstream_incompatibility -eq 1 ]; then
493     msg="-E- We detected an mplayer dumpstream incompatibility earlier."
494     msg="$msg We also detected another condition that requires us to use dumpstream. "
495     msg="$msg\n    Unable to rip this DVD in the mode you requested."
496     fatal_and_exit "$msg"
497   fi
498
499   # use mplayer to create the main VOB file
500   echo "-> Using mplayer to dump the DVD feature title $feature_title to a VOB file directly: $vobfile" | tee -a "$logfile"
501   echo "   mplayer $lang_opts -dumpstream -dumpfile \"$vobfile\" -dvd-device \"$source\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
502   mplayer $lang_opts -dumpstream -dumpfile "$vobfile" -dvd-device "$source" dvd://$feature_title > $dumplog 2>&1
503   if [ $? != 0 ]; then
504     cat $dumplog | grep -v "^A:" >> "$logfile"
505     fatal_and_exit "-E- Mplayer Failed"
506   fi
507   cat $dumplog | grep -v "^A:" >> "$logfile"
508   [[ -e "$dumplog" ]] && [[ $remove_dumplog -eq 1 ]] && rm -f $dumplog
509 }
510
511 function get_audio_id_from_iso {
512   # Adjust our audio ID to find the english audio stream
513   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
514   iso="$1"
515   aidcheck=`tempfile`
516   aid=128
517   mplayer -v -endpos 0 -dvd-device "$iso" dvd://$feature_title > $aidcheck 2>&1
518   grep -q "aid: $aid" $aidcheck
519   while [ $? == 1 ] && [ $aid -lt 159 ]; do
520     (( aid = aid + 1 ))
521     grep -q "aid: $aid" $aidcheck
522   done
523   [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
524   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
525   # mencoder default DVD audio track language selection (english)
526   lang_opts="-aid $aid -alang en"
527 }
528
529 function get_crop_from_iso { 
530   FRAMES=10000
531   echo "-> Detecting black frame border crop value from ISO file"
532   echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device \"$isofile\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
533   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device "$isofile" dvd://$feature_title > $dumplog 2>&1
534   [[ -e "md5sums" ]] && rm -f "md5sums"
535   CROP=`cat $dumplog | grep CROP | tail -1`
536   echo "   Found crop value of $CROP" >> "$logfile"
537   CROP=${CROP#* crop=}
538   CROP=${CROP%%\).*}
539   typeset -i CROPCHECK
540   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
541   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
542   if [ -z "$CROP" ]; then
543     fatal_and_exit "-E- Unable to extract CROP value from iso: $isofile"
544   fi
545   if [ $CROPCHECK -lt 0 ]; then 
546     CROP=""
547   else 
548     CROP=",crop=$CROP"
549   fi
550   echo "   Setting mencoder crop filter to: $CROP"
551 }
552
553 function get_crop_from_vob { 
554   FRAMES=10000
555   echo "-> Detecting black frame border crop value from VOB file"
556   echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark \"$vobfile\" > $dumplog 2>&1" >> "$logfile"
557   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark "$vobfile" > $dumplog 2>&1
558   [[ -e "md5sums" ]] && rm -f "md5sums"
559   CROP=`cat $dumplog | grep CROP | tail -1`
560   echo "   Found crop value of $CROP" >> "$logfile"
561   CROP=${CROP#* crop=}
562   CROP=${CROP%%\).*}
563   typeset -i CROPCHECK
564   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
565   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
566   if [ -z "$CROP" ]; then
567     fatal_and_exit "-E- Unable to extract CROP value from iso: $isofile"
568   fi
569   if [ $CROPCHECK -lt 0 ]; then 
570     CROP=""
571   else 
572     CROP=",crop=$CROP"
573   fi
574   echo "   Setting mencoder crop filter to: $CROP"
575 }
576
577 function get_audio_id_from_vob {
578   # Adjust our audio ID to find the english audio stream
579   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
580   vob="$1"
581   aidcheck=`tempfile`
582   aid=128
583   mplayer -v -endpos 0 "$vob" > $aidcheck 2>&1
584   grep -q "Found audio stream: $aid" $aidcheck
585   while [ $? == 1 ] && [ $aid -lt 159 ]; do
586     (( aid = aid + 1 ))
587     grep -q "Found audio stream: $aid" $aidcheck
588   done
589   [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
590   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
591   # mencoder default DVD audio track language selection (english)
592   lang_opts="-aid $aid -alang en"
593 }
594
595 function check_vob_for_corrupted_start {
596   # check to see if the beginning of the DVD has a form of copy protection
597   # where they have deliberately broken the first X number of frames of the DVD.
598   # If we don't skip these, our resulting VOB file will not play.
599   badvobcheck=`tempfile`
600   endpos=360
601   skip=0
602   mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
603   if [ $? != 0 ]; then
604     fatal_and_exit "-E- Mencoder Failed"
605   fi
606   grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
607   while [ $? == 0 ] && [ $skip -lt $endpos ]; do
608     (( skip = skip + 5 ))
609     echo "-> Bad VOB copy protection detected. Trying new skip value of $skip" | tee -a "$logfile"
610     mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
611     if [ $? != 0 ]; then
612       fatal_and_exit "-E- Mencoder Failed"
613     fi
614     grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
615   done
616   [[ -e "$badvobcheck" ]] && rm -f "$badvobcheck";
617
618   # cat the giant VOB into mencoder to create a playable VOB file
619   cat "$tmpdir/$dvdname.VOB" | mencoder -ss $skip -quiet $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy - -o "$vobfile" >> "$logfile" 2>&1
620   if [ $? != 0 ]; then
621     fatal_and_exit "-E- Mencoder Failed"
622   fi
623 }
624
625 function check_vob_for_completeness {
626   # check to make sure we got out a complete VOB.
627   # there is another kind of copy protection where the VOB's may
628   # have "MPG EOF" frames in the middle of the stream. 
629   # this causes mencoder to not process the entire VOB, and exit without any errors.
630   # detect this by seeing how much smaller the dst vob is from the src vob.
631   MAX_FILESIZE_DELTA_PERCENT=70
632   SRC_VOB_FILESIZE=$(stat -c%s "$tmpdir/$dvdname.VOB")
633   DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
634   FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
635   if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
636     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
637     echo "-> Detected bad VOB size copy protection after processing concatenated VOB file." | tee -a "$logfile"
638     create_main_vob_with_mplayer "$isofile"
639     [[ -e "$dumplog" ]] && rm -f $dumplog
640     DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
641     FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
642     if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
643       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n    I recommend using another ripping mode like '-m' or '-i'"
644     fi
645   fi
646 }
647
648 function check_vob_for_too_many_video_packets {
649   # If our earlier algorithm to work around this failed, throw an error.
650   # check to see if this DVD has a protection scheme we don't know how to work around
651   # when I tried to burn the CARS DVD for example, you can't play the resulting VOB file.
652   # for some reason, the video is black, while the audio rolls, then the video finally comes
653   # in, but it is WAY off the audio. This appears to be due to some bad frames at the beginning of 
654   # the 1st VOB. Until I figure out how to work around this, detect it, and error out.
655   # instead of pulling the image from the disk again, you can pull it directly from the iso: -dvd-device $iso_path
656   grep -q "Too many video packets in the buffer:" "$logfile"
657   if [ $? == 0 ]; then
658     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
659     echo "-> Detected corrupt audio stream copy protection after processing concatenated VOB file." | tee -a "$logfile"
660     create_main_vob_with_mplayer "$isofile"
661     grep -q "Too many video packets in the buffer:" $dumplog
662     if [ $? == 0 ]; then
663       [[ -e "$dumplog" ]] && rm -f $dumplog
664       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
665     fi
666     [[ -e "$dumplog" ]] && rm -f $dumplog
667   fi
668 }
669
670 function check_vob_for_a52_crc_errors {
671   # Let's see if we can playback our newly created VOB file without any errors.
672   # if there are issues, let's detect them now, and try to recreate the VOB
673   # there are some forms of copy protection that have missed above, that evidence
674   # themselves when we try to playback the VOB file. This was added to deal with
675   # the "a52: CRC check failed" copy protection scheme.
676   MAX_ERRORS=10
677   ENDPOS=120
678   echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
679   mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
680   cat $dumplog | grep -v "^A:" >> "$logfile"
681   errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
682   if [ $errors -gt $MAX_ERRORS ]; then
683     echo "-> Detected a52 audio stream CRC errors copy protection after processing concatenated VOB file." | tee -a "$logfile"
684     create_main_vob_with_mplayer "$isofile"
685     echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
686     mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
687     if [ $? != 0 ]; then
688       cat $dumplog | grep -v "^A:" >> "$logfile"
689       fatal_and_exit "-E- Mplayer Failed"
690     fi
691     cat $dumplog | grep -v "^A:" >> "$logfile"
692     errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
693     if [ $errors -gt $MAX_ERRORS ]; then
694       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
695     fi
696   fi
697   [[ -e "$dumplog" ]] && rm -f $dumplog
698 }
699
700 function calculate_bitrate_from_target_size {
701   # determine what our bitrate needs to be if a target size was specified instead
702   if [ $target_size -ne 0 ]; then
703     vob_length=`mplayer -identify -v "$vobfile" -endpos 0 2>&1 | grep ID_LENGTH | awk -F '=' '{ print $2 }' | awk -F '.' '{ print $1 }'`
704     ((target_bitrate = (target_size * 1024 * 8) / vob_length ))
705     echo "   With a given target size of $target_size MB, the estimated bit rate will need to be $target_bitrate kbits/sec"
706   fi
707 }
708
709 function create_dvdauthor_dvd_xml_file {
710   # make a dvdauthor xml menu file to create a valid DVD video from 
711   # this script does a good job, but we'll still need to clean it up a bit after it runs
712   echo "-> Creating dvdauthor XML menu file" | tee -a "$logfile"
713   makexml -overwrite -dvd *.VOB -out dvd >> "$logfile" 2>&1
714   if [ $? != 0 ]; then
715     fatal_and_exit '-E- makexml -dvd *.VOB -out dvd failed'
716   fi
717
718   # replace the first line of the xml file to remove the bad dest path
719   awk -v line=1 -v new_content="<dvdauthor>" '{
720     if (NR == line) {
721       print new_content;
722     } else {
723       print $0;
724     }
725   }' dvd.xml > dvd.xml.new
726   mv -f dvd.xml.new dvd.xml
727   if [ $? != 0 ]; then
728     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
729   fi
730
731   # remove the "<video " property line from the xml file
732   cat dvd.xml | grep -v "<video" > dvd.xml.new
733   mv -f dvd.xml.new dvd.xml
734   if [ $? != 0 ]; then
735     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
736   fi
737   
738   # remove the extra <pgc>..</pgc> pairs
739   cat dvd.xml | awk 'BEGIN {x=1}
740   {
741     if ($0~"</pgc>") {x=0}
742     if (x==1) {print $0}
743     if ($0~"<pgc>") {x=1}
744   }' > dvd.xml.new
745   echo -e "</pgc>\n</titles>\n</titleset>\n</dvdauthor>" >> dvd.xml.new
746   mv -f dvd.xml.new dvd.xml
747   if [ $? != 0 ]; then
748     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
749   fi
750
751   # remove the VTS_*_0.VOB file as this is just the main menu video clip
752   cat dvd.xml | grep -v "VTS_.*_0.VOB" > dvd.xml.new
753   mv -f dvd.xml.new dvd.xml
754   if [ $? != 0 ]; then
755     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
756   fi
757 }
758
759 function check_for_mplayer_dumpstream_incompatibility {
760
761   echo "-> Checking for mplayer dumpstream incompatibilities" | tee -a "$logfile"
762
763   if [ ! -e "$vobfile" ]; then
764     # mplayer dumpstream does not work on DVDs that obscure the feature title.
765     # A DVD that has 99 titles, where the longest title isn't the main feature
766     # breaks mplayer dumpstream. We have to fallback to using dvdbackup to figure
767     # out what the feature title is. This script will run through that flow if we
768     # set use_mplayer_dumpstream to 0. Check for this here.
769     if [ $ripdvd -eq 1 ]; then
770       lsdvd $dev | grep -q "Title: 99"
771     else
772       lsdvd "$isofile" | grep -q "Title: 99"
773     fi
774     # If we have 99 titles and a feature title wasn't given on the command line, switch modes.
775     if [ $? == 0 ] && [ $feature_title_override -eq 0 ]; then
776       if [ $trust_feature_title_autodetect_when_uncertain -eq 0 ]; then
777         echo "-E- Unable to determine the feature title due to the 99 title copy protection scheme" | tee -a "$logfile"
778         echo "    You will need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
779         echo "    You can google this DVD to find out what it's feature title is, or you can play it in a conventional DVD player to find it." | tee -a "$logfile"
780         invalid_feature_title=1
781       else 
782         echo "    Falling back to non mplayer dumpstream methods to copy the DVD" | tee -a "$logfile"
783         echo "-W- We still may not be able to autodetect the right feature title" | tee -a "$logfile"
784         echo "    You may need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
785         use_mplayer_dumpstream=0
786         invalid_feature_title=1
787       fi
788       return
789     fi
790   fi
791
792   # There is another form of protection that causes the mplayer dumpstream to fail. 
793   # This can be detected by telling mplayer to parse the VOB file by copying its audio
794   # video streams to a dummy output file (/dev/null). Do that here to check for that 
795   # problem before continuing.
796   if [ -e "$vobfile" ]; then
797     mplayer_opts="-quiet -ofps 30000/1001 -ffourcc DIVX -oac copy -ovc copy"
798     mencoder $mplayer_opts "$vobfile" -o "/dev/null" > $dumplog 2>&1
799     grep -q "Too many audio packets in the buffer" $dumplog
800     if [ $? == 0 ]; then
801       echo "-> The VOB dumped by mplayer is invalid. Falling back to non mplayer dumpstream to copy the DVD" | tee -a "$logfile"
802       use_mplayer_dumpstream=0
803       mplayer_dumpstream_incompatibility=1
804     fi
805     [[ -e "$dumplog" ]] && rm -f $dumplog
806   fi
807 }
808
809 # encode the vob file into a compressed file format
810 function compress_vob_file {
811   typeset -i found_profile=0
812    
813   if [ "$profile" == "hdtv" ]; then
814     # DIVX 2 pass encoding
815     found_profile=1
816     final_output_file="$dest/$dvdname.avi"
817     mencoder_general_opts="-quiet $lang_opts -passlogfile $passlogfile"
818     mencoder_output_opts="-ofps 30000/1001 -ffourcc DIVX"
819     mencoder_video_filter_opts="-vf pullup,softskip,hqdn3d=2:1:2$CROP$SCALE"
820     mencoder_video_encoder_opts="-ovc xvid -xvidencopts pass=%PASS"
821     video_encoder_opts[0]="bitrate=$target_bitrate"
822     video_encoder_opts[1]="threads=$mencoder_threads"
823     video_encoder_opts[2]="chroma_opt"
824     video_encoder_opts[3]="vhq=4"
825     video_encoder_opts[4]="bvhq=1"
826     video_encoder_opts[5]="quant_type=mpeg"
827     video_encoder_opts[6]="autoaspect"
828     for OPTS in "${video_encoder_opts[@]}"; do 
829       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
830     done
831
832     if [ $audio_2ch -eq 0 ]; then
833       # These options produce good 6 channel audio for linux and windows
834       mencoder_audio_opts="-oac copy"
835       # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
836       mencoder_audioch_opts[0]="-channels 6 -af channels=6"
837       mencoder_audioch_opts[1]="-af channels=6"
838       mencoder_audioch_opts[2]=""
839     else
840       # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
841       mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
842       mencoder_audioch_opts[0]=""
843     fi
844  
845   fi
846
847   if [ "$profile" == "iphone" ] || [ "$profile" == "ipod" ]; then
848     # MP4 encoding 
849     found_profile=1
850     if [ "$profile" == "iphone" ]; then
851       SCALE=",scale=480:320"
852     else
853       SCALE=",scale=320:240"
854     fi
855     final_output_file="$dest/$dvdname.mp4"
856     mencoder_general_opts="-quiet $lang_opts -passlogfile $passlogfile"
857     mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
858     mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
859     mencoder_video_encoder_opts="-ovc x264 -x264encopts pass=%PASS"
860     video_encoder_opts[0]="bitrate=$target_bitrate"
861     video_encoder_opts[1]="threads=$mencoder_threads"
862     video_encoder_opts[2]="vbv_maxrate=1500"
863     video_encoder_opts[3]="vbv_bufsize=2000"
864     video_encoder_opts[4]="nocabac"
865     video_encoder_opts[5]="me=umh"
866     video_encoder_opts[6]="subq=6"
867     video_encoder_opts[7]="frameref=6"
868     video_encoder_opts[8]="trellis=1"
869     video_encoder_opts[9]="level_idc=30"
870     video_encoder_opts[10]="global_header"
871     for OPTS in "${video_encoder_opts[@]}"; do 
872       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
873     done
874
875     mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
876     mencoder_audioch_opts[0]="-channels 2 -srate 48000"
877   fi
878
879   if [ $found_profile -eq 0 ]; then
880     fatal_and_exit "-E- Unable to find a profile handler for profile: $profile"
881   fi
882
883   # Do not edit this line. $mencoder_video_encoder_opts must be last
884   mencoder_opts="$mencoder_general_opts $mencoder_output_opts $mencoder_audio_opts $mencoder_video_filter_opts $mencoder_video_encoder_opts"
885   mencoder_retval=0
886
887   for PASS in 1 2 
888   do 
889     # Set some options based on which pass we are in
890     mencoder_opts_for_pass=$(echo "$mencoder_opts" | sed "s,%PASS,$PASS,g")
891     [ $PASS -eq 1 ] && mencoder_opts_for_pass="$mencoder_opts_for_pass:turbo"
892     [ $PASS -eq 1 ] && output_file="/dev/null"
893     [ $PASS -eq 2 ] && output_file="$final_output_file"
894   
895     # It's possible that the audio channel encoding may not work. Cycle through all our different audioch_opts until we find one that works.
896     for CH_OPTS in "${mencoder_audioch_opts[@]}"; 
897     do
898       echo -e "   Encoding pass $PASS"
899       echo -e "\n   Encoding pass $PASS: mencoder $CH_OPTS $mencoder_opts_for_pass \"$vobfile\" -o \"$output_file\" >> $encodelog 2>&1" >> "$logfile"
900       mencoder $CH_OPTS $mencoder_opts_for_pass "$vobfile" -o "$output_file" > $encodelog 2>&1
901       mencoder_retval=$? 
902       grep -q "\[channels\] Invalid" $encodelog
903       if [ $? != 0 ]; then          
904         break;
905       else
906         echo -e "\n-W- Audio channel encoding error. Falling back to next audio channel encoding scheme." >> "$logfile"
907       fi
908     done
909       
910     if [ $mencoder_retval != 0 ]; then
911       fatal_and_exit "-E- Unhandled mencoder error"
912     fi
913
914     # Concatenate the encode log to our main log file, greping out unwanted lines
915     cat $encodelog | grep -v "Pos:" >> "$logfile"
916
917   done
918 }
919
920 function fill_mythvideo_metadata {
921
922   # This function must be passed the filename as an argument
923   # The filename must be a full path to the file
924   filename="$1"
925
926   # Make sure the fill mythvideo metadata option has been set to 1
927   if [ $fill_mythvideo_metadata -eq 0 ]; then
928     echo "-> fill_mythvideo_metadata=0 therefore not updating mythvideo metadata for this rip" | tee -a "$logfile"
929     return 0
930   fi
931
932   # If the fill mythvideo metadata script is present, run it
933   # fill_mythvideo_metadata.plThis will download the metadata for the DVD we ripped.
934   if [[ -x `which fill_mythvideo_metadata.pl` ]]; then
935     echo "-> Running fill_mythvideo_metadata.pl to lookup/add/update the metadata for this DVD: $filename" | tee -a "$logfile"
936     fill_mythvideo_metadata.pl -N 0 -F "$filename" >> "$logfile" 2>&1
937   else
938     echo "-W- Unable to find the fill_mythvideo_metadata.pl script in your PATH. Unable to autofill the mythvideo DB for this rip." | tee -a "$logfile"
939     echo "    Set the fill_mythvideo_metadata variable to 0 in the script to avoid running this step." | tee -a "$logfile"
940   fi
941 }
942
943 # remove the intermediate VOB file
944 function remove_intermediate_vob_file {
945   if [ $keep_intermediate_files -eq 0 ]; then
946     [[ -e "$tmpdir/$dvdname.VOB" ]] && rm -f "$tmpdir/$dvdname.VOB"
947   else
948     echo "-> Keeping intermediate concatenated VOB file: $tmpdir/$dvdname.VOB" | tee -a "$logfile"
949   fi
950 }
951
952 # remove the original DVD image 
953 function remove_intermediate_iso_file {
954   [[ $keep_isofile -eq 1 ]] && return 1
955   if [ $keep_intermediate_files -eq 0 ]; then
956     [[ -e "$isofile" ]] && rm "$isofile"
957   else
958     echo "-> Keeping ddrescue intermediate iso file: $isofile" | tee -a "$logfile"
959   fi
960 }
961
962 # remove the intermediate dvdbackup folder
963 function remove_intermediate_dvdbackup_folder {
964   if [ $keep_intermediate_files -eq 0 ]; then
965     [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
966   else
967     echo "-> Keeping intermediate dvdbackup folder: $tmpdir/$dvdname" | tee -a "$logfile"
968   fi
969 }
970
971 ##############################################################################################
972 # MAIN
973 ##############################################################################################
974
975 # Make a note of when this DVD rip started
976 date=`date`
977 echo -e "\n$date DVD rip started" >> "$logfile"
978
979 # Rip the DVD - Mirror Mode
980 if [ $mirror_mode -eq 1 ]; then
981   echo "-> Ripping DVD $dvdname to $dest"
982
983   # use ddrescue to make an ISO image of the disk
984   make_dvd_iso_image "$dest/$dvdname.iso"
985
986   # add this video data to the mythtv DB
987   fill_mythvideo_metadata "$dest/$dvdname.iso" 
988
989   # eject the disk upon completion
990   eject -T $dev
991
992   date=`date`
993   echo "$date DVD rip completed" | tee -a "$logfile"
994
995   if [[ -n "$mailto" ]]; then
996     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
997   fi
998
999 fi
1000
1001 # Rip the DVD - Main Title Feature Only
1002 if [ $mirror_mode -eq 0 ]; then
1003
1004   # Rip image from DVD
1005   if [ $ripdvd -eq 1 ]; then
1006     echo "-> Ripping DVD $dvdname to $dest" | tee -a "$logfile"
1007     # use ddrescue to make an ISO image of the disk
1008     make_dvd_iso_image "$tmpdir/$dvdname.iso"
1009   fi
1010
1011   # Rip image from DVD path
1012   if [ -n "$dvdpath" ]; then
1013     echo "-> Ripping DVD $dvdpath to $dest" | tee -a "$logfile"
1014     make_dvd_iso_image_from_folder "$dvdpath" "$tmpdir/$dvdname.iso" 1
1015   fi
1016
1017   # make sure our isofile value is set
1018   if [ -z "$isofile" ]; then
1019     isofile="$tmpdir/$dvdname.iso"
1020   fi
1021      
1022   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
1023
1024     if [ ! -e "$vobfile" ]; then
1025       echo "-> Creating DVD video $vobfile" | tee -a "$logfile"
1026       
1027       # get the feature title from the ISO
1028       get_feature_title "$isofile"
1029  
1030       # get the crop value from the ISO
1031       get_crop_from_iso
1032
1033       # check for mplayer dumpstream incompatibilities
1034       # if they exist, this method will set this mode to 0.
1035       check_for_mplayer_dumpstream_incompatibility
1036
1037       if [ $use_mplayer_dumpstream -eq 1 ]; then 
1038
1039         # get our audio id from the ISO file
1040         get_audio_id_from_iso "$isofile"
1041
1042         # create our main VOB file from the ISO
1043         create_main_vob_with_mplayer "$isofile"
1044      
1045         # remove the intermediate VOB file
1046         remove_intermediate_vob_file
1047
1048         # it's possible that our VOB is still corrupted in some manner
1049         # check to make sure it is still a good VOB before continuing.
1050         check_for_mplayer_dumpstream_incompatibility
1051
1052       fi
1053  
1054       if [ $use_mplayer_dumpstream -eq 0 ]; then 
1055
1056         # use dvdbackup to make a DVD folder of the feature title
1057         make_dvdbackup_folder_image
1058   
1059         # create our main VOB file
1060         create_main_vob_with_cat
1061
1062         # get our audio id from the VOB file
1063         get_audio_id_from_vob "$tmpdir/$dvdname.VOB"
1064   
1065         # check for corrupted VOB start
1066         check_vob_for_corrupted_start
1067  
1068         # check to make sure our VOB is complete
1069         check_vob_for_completeness
1070
1071         # check to make sure our VOB doesn't have too many video packets
1072         check_vob_for_too_many_video_packets
1073
1074         # check to make sure our VOB doesn't have a52 crc errors
1075         check_vob_for_a52_crc_errors
1076
1077         # remove the intermediate VOB file
1078         remove_intermediate_vob_file
1079
1080       fi
1081
1082       # remove the intermediate ISO file
1083       remove_intermediate_iso_file
1084
1085     else
1086       echo "-> Skipping VOB creation. VOB DVD video already exists: $vobfile" | tee -a "$logfile"
1087       # get our audio id from the VOB file
1088       get_audio_id_from_vob "$vobfile"
1089       # get the crop value from the VOB
1090       get_crop_from_vob
1091     fi
1092
1093     # encode the VOB file to a compressed file format
1094     if [ $make_final_dest_comp -eq 1 ]; then
1095       echo "-> Encoding the DVD video to a compressed file" | tee -a "$logfile"
1096
1097       # determine what our bitrate needs to be if a target size was specified instead
1098       calculate_bitrate_from_target_size        
1099      
1100       # encode the vob file into a compressed file format
1101       compress_vob_file
1102
1103       if [ $keep_intermediate_files -eq 0 ] && [ $make_final_dest_vob -eq 0 ]; then
1104         [[ -e "$vobfile" ]] && [[ $keep_vobfile -eq 0 ]] && rm -f "$vobfile";
1105         [[ -e "$passlogfile" ]] && rm -f "$passlogfile";
1106       else
1107         echo "-> Keeping VOB file: $vobfile" | tee -a "$logfile"
1108         echo "-> Keeping mencoder 2pass logfile: $passlogfile"
1109       fi
1110     fi
1111
1112   # add this video data to the mythtv DB
1113   [ $make_final_dest_comp -eq 1 ] && fill_mythvideo_metadata "$final_output_file" 
1114   [ $make_final_dest_vob -eq 1 ] && fill_mythvideo_metadata "$vobfile" 
1115     
1116   else
1117
1118   # use dvdbackup to make a DVD folder of the feature title
1119   make_dvdbackup_folder_image
1120
1121   # cd to the feature title DVD folder
1122   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
1123   if [ $? != 0 ]; then
1124     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
1125   fi
1126   
1127   # create the dvd.xml file for dvdauthor
1128   create_dvdauthor_dvd_xml_file  
1129
1130   # make the final DVD folder image
1131   make_dvdauthor_folder_image
1132
1133   # add this video data to the mythtv DB
1134   fill_mythvideo_metadata "$dest/$dvdname/VIDEO_TS" 
1135  
1136   # cd back to the dir we started from
1137   popd > /dev/null 2>&1
1138
1139   if [ $make_final_dest_iso -eq 1 ]; then
1140
1141     # make an iso image out of our directory
1142     make_dvd_iso_image_from_folder "$dest/$dvdname" "$dest/$dvdname.iso" 0
1143    
1144     # If the mkisofs was unable to make a .iso file for us, don't remove the DVD directory 
1145     if [ -s "$dest/$dvdname.iso" ]; then
1146       if [ $make_final_dest_folder -eq 0 ]; then
1147         echo "-> Removing DVD folder since ISO was created: $dest/$dvdname" | tee -a "$logfile"
1148         # remove the folder of the DVD image now that we have a .iso version of it
1149         [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
1150       fi
1151     else
1152       # we created an empty iso file, remove it
1153       echo "-> Removing empty ISO image: $dest/$dvdname.iso" | tee -a "$logfile"
1154       echo "-> Keeping the DVD folder since the ISO image couldn't be created properly: $dest/$dvdname"
1155       [[ -e "$dest/$dvdname.iso" ]] && rm "$dest/$dvdname.iso"
1156     fi
1157  
1158     # add this video data to the mythtv DB
1159     fill_mythvideo_metadata "$dest/$dvdname.iso" 
1160
1161   fi
1162
1163   fi
1164
1165   # remove the ddrescue DVD ISO image
1166   remove_intermediate_iso_file
1167
1168   # remove the tmp dvdbackup folder of the DVD image
1169   remove_intermediate_dvdbackup_folder
1170
1171   # eject the DVD disk upon completion
1172   [ $ripdvd -eq 1 ] && eject -T $dev
1173
1174   date=`date`
1175   echo "$date DVD rip completed" | tee -a "$logfile"
1176
1177   if [[ -n "$mailto" ]]; then
1178     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1179   fi
1180
1181 fi
1182
1183 ##############################################################################################